[LeetCode]Two Sum

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

import java.util.HashMap;
public class Solution {
    static public int[] twoSum(int[] numbers, int target) {
        HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();
        for (int i=0; i<numbers.length; i++){
            map.put(numbers[i], i+1);
        }
        for (int i=0; i<numbers.length; i++){
			//!=null:has two value can achieve the target by adding
			//>i+1: make sure index1 < index2
            if (map.get(target - numbers[i]) != null && map.get(target - numbers[i]) > i+1){
                int[] result = new int[2];
                result[0] = i+1;//index of smaller one 
                result[1] = map.get(target - numbers[i]);//index of larger one
                return result;
            }
        }
        return null;
    }
	
	public static void main(String[] args){
		int[] numbers={2, 7, 15, 11};
		int target=9;
		int[] n = twoSum(numbers,target);
		System.out.println(n[0] + "," + n[1]);
	}
}

O(n2) runtime, O(1) space – Brute force:

The brute force approach is simple. Loop through each element x and find if there is another value that equals to target – x. As finding another value requires looping through the rest of array, its runtime complexity is O(n2).

O(n) runtime, O(n) space – Hash table:

We could reduce the runtime complexity of looking up a value to O(1) using a hash map that maps a value to its index.


Other solutions:

First quicksort(array), then

    public int[] twoSum(int[] numbers, int target) {
		int i = 0;
		int j = numbers.length-1;
        while(i<j){
            if(numbers[i] + numbers[j] == target){
                int[] twoIndex = {i+1,j+1};
                return twoIndex;
            }
			else if(numbers[i] + numbers[j] > target){
				j--;
			}
            else{
                i++;
            }
        }
		return null;
    }


T(n) = O(nlgn) + O(n)



评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值